/**************************************************************


        CODE CONVERTER  

                input  :  KSC 5601 code 
                output :  N byte Standard code for FAST 15.

        Programmed by Choyh in KAIST, Korea.  05/18/90 
                Email :  choyh@csdsun.kaist.ac.kr   

***************************************************************/



#include <stdio.h>
#include "hantbl.h"

#define  ENG    0
#define  KOR    1

char Cho_tbl[21] =
        { 0,0,65,66,68,71,72,73,81,82,83,85,86,87,88,89,90,
          91,92,93,94};
char Jung_tbl[30] =
        { 0,0,98,99,0,100,101,102,0,103,106,107,0,108,108,
          108,0,108,114,115,0,115,115,115,0,119,122,122,0,124};
char Jung_ant[30] = 
        { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,99,0,124,
          0,0,0,102,103,124,0,0,0,124,0,0 }; 
char Jong_tbl[29] =
        { 0,0,65,66,65,68,68,68,71,73,73,73,73,73,73,73,73,81,
          82,82,85,86,87,88,90,91,92,93,94};
char Jong_ant[30] = 
        { 0,0, 0, 0,85, 0,88,94, 0, 0,65,81,82,85,92,93,94,
           0, 0,85, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int  C_Mode=ENG;

main()
{ int i; 
  unsigned char  c1,c2;
  int                c;

        while(1) 
           { c=fgetc(stdin);
             if(c == EOF)  exit(0);
             c1 = (unsigned)c;
	if(c1!='
'){
             if(c1&0x80) 
              {  if(C_Mode == ENG) putchar(14);
                 C_Mode = KOR;
                 i=0; i= i^c1; i= i<<8; c2=fgetc(stdin); i= i^c2; 
                 intoNbyte(intoCom(i));
              } 
              else 
              {  if(C_Mode == KOR) putchar(15);
                 C_Mode = ENG;
                 putchar(c1);
              }
	}
           }
}
/****   Function which make KSC2S code from Hangule-Character   */
/*      Binary Search algorithm used (Assume ksc2c-ksc2s sorted)*/
int intoCom(key)
int key;
{ int l,u,m,tmp;

        l=0; u= KSC_SIZE -1;
        while(l<=u)
        {       m = (l+u)/2;
                tmp = KSC2CS[m][1];
                if(key  > tmp)  l = m+1;
                else if(key == tmp)  return(KSC2CS[m][0]);
                else if(key  < tmp)  u = m-1;
        }
        l=0; u=KEY_SIZE -1;
        while(l<=u)
        {       m = (l+u)/2;
                tmp = KSC2S_C[m][1];
                if(key  > tmp)  l = m+1;
                else if(key == tmp)  return(KSC2S_C[m][0]);
                else if(key  < tmp)  u = m-1;
        }
        return(key);
}

intoNbyte(key)
int key;
{  int cho,jung,jong,i=0;
   char Nbyte[10];

        cho = (key & 0x7c00) >> 10;
        jung= (key & 0x03e0) >> 5;
        jong= (key & 0x001f); 

        Nbyte[i]  = Cho_tbl[cho -8];  if(Nbyte[i]) i++;
        Nbyte[i]  = Jung_tbl[jung];   if(Nbyte[i]) i++;
        if(Jung_ant[jung]) Nbyte[i++]  = Jung_ant[jung];
        Nbyte[i]  = Jong_tbl[jong];   if(Nbyte[i]) i++;
        if(Jong_ant[jong]) Nbyte[i++]  = Jong_ant[jong];
        Nbyte[i] = '\0';
        printf("%s",Nbyte);
}

/***  end of ks2n.c  ***/
